# LIGO Grid Mapfile Manager - LGMM

## Usage

```
Usage: lgmm [options]

LIGO Grid Mapfile Manager

Options:
  --version             show program's version number and exit
  -h, --help            show this help message and exit
  -c CONFIG_FILE_PATH, --config=CONFIG_FILE_PATH
                        path to config file [default is
                        /etc/lgmm/lgmm_config.py]
  --dump-vars           Dump configuration and exit
  --sources=SOURCES     Comma separated list of additional sources. [default
                        is default]

  Gridmapfile Input Options:
    -b BLACKLIST, --blacklist=BLACKLIST
                        grid-mapfile blacklist file [default is NONE]
    -w WHITELIST, --whitelist=WHITELIST
                        grid-mapfile whitelist in grid-mapfile format [default                                                       
                        is None]                                                                                                     
    -i INFILE, --infile=INFILE                                                                                                       
                        File from which to read existing mappings [default is                                                        
                        /etc/grid-security/grid-mapfile]                                                                             
                                                                                                                                     
  Gridmapfile Output Options:                                                                                                        
    -g OUTFILE, -o OUTFILE, --grid-mapfile=OUTFILE, --outfile=OUTFILE                                                                
                        File to which to write mappings [default is /etc/grid-                                                       
                        security/grid-mapfile]                                                                                       
    --sort=SORT         sorting callable for sorting grid-mapfile [default is                                                        
                        None]                                                                                                        
    --no-local-accounts                                                                                                              
                        Do not add mappings to local accounts and only include                                                       
                        certificates subjects [default is FALSE]                                                                     
    -f, --force         force new logins into new grid-mapfile [default is                                                           
                        False]                                                                                                       
    --dry-run           do not write any output [default is False]                                                                   
                                                                                                                                     
  Logging Options:                                                                                                                   
    --log-file=LOGFILE  path to logfile [default is /var/log/lgmm/lgmm.log]                                                          
    --log-level=LOG_LEVEL                                                                                                            
                        one of DEBUG, INFO, WARN, ERROR, CRITICAL, FATAL                                                             
                        [default is INFO]                                                                                            
                                                                                                                                     
  Daemon Options:                                                                                                                    
    -d, --daemon        detach and become daemon [default is False]                                                                  
    --pid-file=PIDFILE  path to pidfile [default is /var/run/lgmm/lgmm.pid]                                                          
    --sleep-time=SLEEP_TIME
                        sleep time between processing cycles [default is 300
                        seconds]
    --random-delay      if daemonized, delay startup by random time up to
                        sleep time to load balance LDAP server [default is
                        enabled, use --no-random-delay to disable]
    --user=USER         user to run as when daemon [default is nobody]

  LDAP Host Options:
    Add source specific options using --argument_source=...

    -U LDAP_URLS, --ldap-urls=LDAP_URLS
                        list of LDAP URLs separated by ',' [default is [
                        'ldaps://ldap.ligo.org', 'ldaps://ldap.phys.uwm.edu'
                        ]]
    -B LDAP_BASE, --ldap-base=LDAP_BASE
                        LDAP search base [default is dc=ligo,dc=org]
    -S LDAP_SCOPE, --ldap-scope=LDAP_SCOPE
                        LDAP search scope, can be one of "base", "onelevel" or
                        "subtree" [default is "subtree"]
    --site-attr=SITE_ATTR
                        Login attribute 'site' option. {site} is replaced by
                        SITE argument. [default is 'x-ligo-uid-{site}']

  LDAP Search Options:
    Add source specific options using --argument_source=...

    --groups=GROUPS     required membership groups separated by ','. If
                        specified multiple times each set of required groups
                        are combined in OR fashion. [default is
                        Communities:LSCVirgoLIGOGroupMembers]
    -m MEMBER_ATTR, -M MEMBER_ATTR, --membership-attribute=MEMBER_ATTR
                        LDAP attribute indicating group membership [default is
                        isMemberOf]
    -L LOGIN_ATTR, --login-attribute=LOGIN_ATTR
                        LDAP attribute indicating local logins [default is
                        x-LIGO-uid]
    --subject-attribute=SUBJECT_ATTR
                        LDAP attribute indicating grid subject [default is
                        gridX509subject]
    --filter=FILTER     custom LDAP filter in standard query format e.g
                        '(attribute=value)' [default is '']

  Additional Processing Options:
    Add source specific options using --argument_source=...

    -s SITE, --site=SITE
                        site for which to generate grid-mapfile [default is
                        None]
    --login-whitelist=LOGIN_WHITELIST
                        Comma separated list of allowed logins. [default is
                        None]
    --username-policy=USERNAME_POLICY
                        Policy on how to order site and global usernames, in
                        the case that both exist. Acceptable values are
                        "SITE_ONLY", "SITE_FIRST", "GLOBAL_ONLY",
                        "GLOBAL_FIRST" [default is "SITE_ONLY"]
    --login-groups-map=LOGIN_GROUPS_MAP
                        Map local logins to groups. Each entry takes the form
                        login[,login]:group[,group]... where a user is
                        required to be in all groups in the list. [Default
                        None]
    --subject-transform=SUBJECT_TRANSFORM
                        Whether to transform subject dn from  LDAP to grid
                        format. Acceptable values are "AUTO", "NONE", "FORCE"
                        [default is "AUTO"]
    -O OVERRIDES, --overrides=OVERRIDES
                        List of override rules [default is None]
```

## Testing

Ensure that any changes pass the unit tests and comply with the [Black](https://github.com/psf/black) source code formatter.

