# -*- coding: utf-8 -#-
# Copyright (2020) Cardiff University (macleoddm@cardiff.ac.uk)

"""Build configuration for ligo-grid-mapfile-manager
"""

import re
from pathlib import Path

from setuptools import setup

__author__ = "Duncan Macleod <duncan.macleod@ligo.org>"


def find_version(path, varname="__version__"):
    """Parse the version metadata in the given file.
    """
    with Path(path).open('r') as fobj:
        version_file = fobj.read()
    version_match = re.search(
        r"^{0} = ['\"]([^'\"]*)['\"]".format(varname),
        version_file,
        re.M,
    )
    if version_match:
        return version_match.group(1)
    raise RuntimeError("Unable to find version string.")


# this function only manually specifies things that aren't
# supported by setup.cfg (as of setuptools-30.3.0)
setup(
    version=find_version(Path('lgmm') / "__init__.py"),
    data_files=[
        (str(Path("etc") / "lgmm"), [str(Path("etc") / "lgmm_config.py")]),
    ]
)
